<?php
/*
 * CHeMS (Content HElper Management System)
 * Copyright (C) 2007-2008  Claudio M. Alessi
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
*/

/*
 * Posts manager module
 *
 * There is only a format operator provided which returns the
 * number of pages in "posts.inc": %[posts_total] .
*/

// Includes all the needed routines
require_once("posts_mgr_functions.php");

/*
 * The CHeMS module get function
*/
function posts_mgr_main()
{
   require(FILE_MODCONF);

   // Check if the posts file exists
   if( ! file_exists(MOD_POSTSMGR_DB) )
      return NULL;

   // Include the file (insert the posts) 
   require(MOD_POSTSMGR_DB);
   
   $text .= "\n
      <div id='mod_post' class='chems_module'>
         <div class='chems_module_title'>".MOD_POSTSMGR_POST_TITLE."</div>\n";

   /*
    * Generate the links
   */

   $text .= "\n<div class='chems_module_body'>";

   // Ascending order
   if( MOD_POSTSMGR_POST_SORT === "asc" ) {

      $epost = (MOD_POSTSMGR_POST_MAX ? MOD_POSTSMGR_POST_MAX : $posts);

      for($p = 1; $p <= $epost; $p++)
         $text .= "<a href='?modname=posts_mgr&amp;post=$p'>".$POST[$p]['title']."</a><br />";
   }

   // Descending order
   else {
      if( ! MOD_POSTSMGR_POST_MAX )
         $epost = 0;
      else if($posts && $posts > MOD_POSTSMGR_POST_MAX)
         $epost = $posts - MOD_POSTSMGR_POST_MAX;

      for($p = $posts; $p > $epost; $p--)
         $text .= "<a href='?modname=posts_mgr&amp;post=$p'>".$POST[$p]['title']."</a><br />";
   }
	          
   $text .= "</div></div>\n";

   return str_replace("%[posts_total]", $posts, $text);
} /* eof_posts_mgr_page() */

/*
 * Posts module page
*/
function posts_mgr_page()
{
   require(MOD_POSTSMGR_DB);

   if( ($id = $_GET['post']) ) {
      $page_current = ($id < 1 || $id > $posts ? 0 : $id);

      // Check if the post is valid and exists
      if( ! ($page_current && ($post = getPost($id, 0, NULL))) )
         return MOD_POSTS_MSGNOPOST;
         
      $text = "<div id='post_$id' class='post'>$post</div>";
   }
   else {
      // Get the inf/sup extremes
      xtrset($posts, MOD_POSTS_POSTSPERPAGE, $einf, $esup);

      // Check if it's a valid posts range
      if( ! ($einf && $esup) )
         return MOD_POSTS_MSGNOPOST;
      
      // Generates the spaces
      for($i = 0; $i < MOD_POSTS_SPACES; $i++)
         $spaces .= "<br />"; 

      // Get the posts
      for($p = $esup; $p >= $einf; $p--) {

         /*
          * Check if the current posts exists..
          * This condition should never occurr since the
          * MOD_POSTSMGR_DB file always have progressive IDs.
         */
         if( ! ($post = getPost($p, MOD_POSTS_MAXLEN, MOD_POSTS_SUSP)) )
	    $post = MOD_POSTS_MSGNOPOST;

	 // Add the post to the page
	 // (expanding the %[elem_curr] format operator)
         $text .= str_replace("%[elem_curr]", $p, $post);

	 // It's NOT the last post
	 if( $p > $einf ) {
	    /* Include the spaces between posts */
	    $text .= $spaces;
	 }
      }
   }

   return $text;
} /* eof posts_mgr_page() */

?>
