<?php
/*
 * CHeMS (Content HElper Management System)
 * Copyright (C) 2007-2008  Claudio M. Alessi
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
*/

// Routines and configuration
require_once("functions.php");
require_once(FILE_CONFIG);

// Store the module name
if( ! ($module->modname = $_GET['modname']) )
   $module->modname = DEF_MODNAME;

/*
 * Generate the menubar(s), if any.
*/
if( $MODULES[0] ) {

   // Create the $brs variable
   for($sp = 0; $sp < MODULES_SPACES; $sp++, $brs .= "<br />")
      ;

   // Generate the modules
   for($m = 0; ($mod = $MODULES[$m]); $m++) {

      // Provide an instance ID for the modules blocks
      $instidx = "mod_".$mod["name"]."_instance";
      $module->instid = (!isset($modinst[$instidx]) ? 0 : ++$modinst[$instidx]);

      // Store the module informations
      foreach($mod as $key => $val)
         $module->{$key} = $val;

      /*
       * Only the modules currently loaded which are members
       * of the current module page and has not been toggled
       * have to be included. All the others are just ignored.
      */
      if( ((istoggled($mod["mods"], $module->modname)
            || $mod["mods"] === "all")
	    ^  istoggled($mod["toggle"], $module->modname))
	    && (istoggled(MENUBAR, $mod["side"]) || MENUBAR === "all" )
      ) {
         
         /*
          * Include the current module into the list. The $brs list is appended
          * only if it's not the last module into the current menu. If the side
          * is "top" then a <br /> is put before the module else if the side is
          * "bottom" the <br /> is put after it.
         */
         ${"menu_".$mod["side"]} .=
            ( (($mod["side"] === "left" || $mod["side"] === "right") &&
	        ${"menu_".$mod["side"]}) ? $brs :
	       ($mod["side"] === "bottom" ? "<br />" : "")) .
	       getModFunc($mod["name"], "_main") .
	       ($mod["side"] === "top" ? "<br />" : "");
      }

      // Clear the module informations
      foreach($mod as $key => $val)
         $module->{$key} = "";

   }
}

themeLoad($theme, CHEMS_THEME);	// Load the theme

// Set the HTTP header content type and character encoding
header('Content-type: application/xhtml+xml; charset=utf-8');

/*
 * Ok, now i can print the "real" page by output all the XHTML code
 * and the dinamically generated content. I'll describe shortly the
 * following code. Open the main tags <html>, <head>, <body>, etc.,
 * so i can put the menus, layout divs and their relative contents.
 * Then i check if the MODULES_SECURE option is enabled and if true
 * check if the current module is effectively loaded. At this point
 * it's possible to finally add the top and bottom menu, the module
 * page and the closing tags for the divs, all encoded in UTF-8 (if
 * the USE_UTF8 option is enabled). I know, the code is a bit weird
 * (to look at) but it's as compact as i like! Please, feel free to
 * change it in order to fit your needs.
*/
print "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.1//EN\"
   \"http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd\">

<html xmlns=\"http://www.w3.org/1999/xhtml\" dir=\"ltr\" xml:lang=\"$theme->lang\">

   <head>
      <title>".CHEMS_APP_TITLE."</title>

      <!-- StyleSheet and Favicon -->
      <link rel=\"stylesheet\" type=\"text/css\" href=\"$theme->css\" />
      <link rel=\"icon\" href=\"$theme->favicon\" type=\"image/x-icon\" />
      <link rel=\"shortcut icon\" href=\"$theme->favicon\"
            type=\"image/x-icon\" />
      <style type='text/css'>@import url('$theme->css');</style>

      ".CHEMS_SECTION_HEAD."
   </head>

   <body>
      <div id='header'>
         <div class='incol'>".CHEMS_HEADER."</div>
      </div> <!-- header -->

      <div id='layout'>
         <div id='main'>
            <div id='menu_left'><div class='incol'>$menu_left</div></div> <!-- menu_left -->
            <div id='menu_right'><div class='incol'>$menu_right</div></div> <!-- menu_right -->
            <div id='main_page_body'>" . ( ! USE_UTF8 ? "" : utf8_encode("
               <div class='incol'>" .
                  ( ((istoggled(MODULES_SECURE, $common->modname) ||
	              MODULES_SECURE === "all") &&
		      ! modisload($MODULES, $module->modname)) ?
                    str_replace("%[modname]", $module->modname, MODULES_MSG_UNSECMOD) :
                    $menu_top . "
                  <div id='mod_$module_modname' class='mod'>" .
		     getModFunc($module->modname, "_page")."
                  </div>" .
                  $menu_bottom) . "
               </div>
            </div> <!-- main_page_body -->
	    ")) . "
            <div class='cleaner'>&nbsp;</div>
         </div> <!-- main -->
      </div> <!-- layout -->

      <div id='footer'><div class='incol'><p>".CHEMS_FOOTER."</p></div></div>
   </body>

</html>
";

?>
